# encoding: utf8
#
# Un programa para simular en una dimensión la colisión
# de una caja contenida entre otras dos
#
# Fraga 11/10/2017

import objetos
import subprocess
import time
import sys

# La escena consta de cuatro cajas y dos planos:
caja1 = objetos.Caja(  1, 0,  4, 6 )
caja2 = objetos.Caja( 11, 0, 13, 4 )
piso  = objetos.Caja(  0, -0.4, 14, 0 )
caja_movil = objetos.Caja( 7, 0, 8, 1 )

plano1 = objetos.Plano(  4.0, 6.0,  1.0, 0.0 )
plano2 = objetos.Plano( 11.0, 0.0, -1.0, 0.0 )


def dibuja ( ) :
	try:
		arch = open( "escena.txt", "w" )
	except:
		print "No puedo abrir archivo se salida"
		sys.exit(1)

	caja1.dibuja( arch )
	caja2.dibuja( arch )
	piso.dibuja( arch )
	caja_movil.dibuja( arch )

	arch.close( )

plot = subprocess.Popen('/opt/local/bin/gnuplot', stdin=subprocess.PIPE, stdout=subprocess.PIPE )
plot.stdin.write("""
set term x11

set xrange [0:14]
set yrange [-0.5:7]
set size ratio -1
unset key
unset tics
unset border
""" )

dx = 1.7
d = 0

deltat = 0.5
tiempo_simulacion = 20
bandera = 0

# En un ciclo :
t = 0
while t < tiempo_simulacion :
	time.sleep( deltat );
	t += deltat 

	# cambio el sentido de movimiento a los 10 segundos
	if bandera == 0 :
		if t > 10 :
			dx *= -1
			bandera = 1

	# dibujamos
	dibuja( )
	plot.stdin.write( "plot 'escena.txt' w l lw 2\n" )

	# transladamos la caja móvil
	caja_movil.translada( dx )

	# checamos la colisiones
	r = caja_movil.prueba( caja1 )
	if r == 1 :
		d = plano1.distancia( caja_movil )		
		caja_movil.translada( d )
	else :
		d = 0
		
	r = caja_movil.prueba( caja2 )
	print "r =", r
	if r == 1 :
		d = plano2.distancia( caja_movil )		
		print "d =", d
		caja_movil.translada( d )
	else :
		d = 0

time.sleep( 2 )
print "Bye!"
plot.terminate()
